diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/block-ack-window.h ns-3.31/src/wifi/model/block-ack-window.h
--- ns-3.30.1/src/wifi/model/block-ack-window.h	2019-09-18 10:36:11.000000000 -0700
+++ ns-3.31/src/wifi/model/block-ack-window.h	2020-06-27 17:38:30.000000000 -0700
@@ -27,7 +27,7 @@
 
 /**
  * \ingroup wifi
- * \brief Block Ack window
+ * \brief Block ack window
  *
  * This class provides the basic functionalities of a window sliding over a
  * bitmap: accessing any element in the bitmap and moving the window forward
@@ -68,22 +68,22 @@
    */
   void Init (uint16_t winStart, uint16_t winSize);
   /**
-   * Reset the window by clearing all the elements and setting winstart to the
+   * Reset the window by clearing all the elements and setting winStart to the
    * given value.
    *
    * \param winStart the window start
    */
   void Reset (uint16_t winStart);
   /**
-   * Get the current winstart value.
+   * Get the current winStart value.
    *
-   * \return the current winstart value
+   * \return the current winStart value
    */
   uint16_t GetWinStart (void) const;
   /**
-   * Get the current winend value.
+   * Get the current winEnd value.
    *
-   * \return the current winend value
+   * \return the current winEnd value
    */
   uint16_t GetWinEnd (void) const;
   /**
@@ -94,25 +94,25 @@
   std::size_t GetWinSize (void) const;
   /**
    * Get a reference to the element in the window having the given distance from
-   * the current winstart. Note that the given distance must be less than the
+   * the current winStart. Note that the given distance must be less than the
    * window size.
    *
    * \param distance the given distance
    * \return a reference to the element in the window having the given distance
-   *         from the current winstart
+   *         from the current winStart
    */
   std::vector<bool>::reference At (std::size_t distance);
   /**
-   * Advance the current winstart by the given number of positions.
+   * Advance the current winStart by the given number of positions.
    *
-   * \param count the number of positions the current winstart must be advanced by
+   * \param count the number of positions the current winStart must be advanced by
    */
   void Advance (std::size_t count);
 
 private:
   uint16_t m_winStart;         ///< window start (sequence number)
   std::vector<bool> m_window;  ///< window
-  std::size_t m_head;          ///< index of winstart in the vector
+  std::size_t m_head;          ///< index of winStart in the vector
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/cara-wifi-manager.cc ns-3.31/src/wifi/model/cara-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/cara-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/cara-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -36,10 +36,10 @@
  */
 struct CaraWifiRemoteStation : public WifiRemoteStation
 {
-  uint32_t m_timer; ///< timer count
+  uint32_t m_timer;   ///< timer count
   uint32_t m_success; ///< success count
-  uint32_t m_failed; ///< failed count
-  uint8_t m_rate; ///< rate
+  uint32_t m_failed;  ///< failed count
+  uint8_t m_rate;     ///< rate in bps
 };
 
 NS_OBJECT_ENSURE_REGISTERED (CaraWifiManager);
@@ -131,7 +131,7 @@
 CaraWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  CaraWifiRemoteStation *station = (CaraWifiRemoteStation *) st;
+  CaraWifiRemoteStation *station = static_cast<CaraWifiRemoteStation*> (st);
   station->m_timer++;
   station->m_failed++;
   station->m_success = 0;
@@ -162,11 +162,11 @@
 }
 
 void
-CaraWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                 double ackSnr, WifiMode ackMode, double dataSnr)
+CaraWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                 double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  CaraWifiRemoteStation *station = (CaraWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  CaraWifiRemoteStation *station = static_cast<CaraWifiRemoteStation*> (st);
   station->m_timer++;
   station->m_success++;
   station->m_failed = 0;
@@ -200,11 +200,10 @@
 CaraWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  CaraWifiRemoteStation *station = (CaraWifiRemoteStation *) st;
+  CaraWifiRemoteStation *station = static_cast<CaraWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, station->m_rate);
@@ -220,13 +219,12 @@
 CaraWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  CaraWifiRemoteStation *station = (CaraWifiRemoteStation *) st;
+  CaraWifiRemoteStation *station = static_cast<CaraWifiRemoteStation*> (st);
   /// \todo we could/should implement the Arf algorithm for
   /// RTS only by picking a single rate within the BasicRateSet.
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiTxVector rtsTxVector;
@@ -245,17 +243,11 @@
 
 bool
 CaraWifiManager::DoNeedRts (WifiRemoteStation *st,
-                            Ptr<const Packet> packet, bool normally)
+                            uint32_t size, bool normally)
 {
-  NS_LOG_FUNCTION (this << st << normally);
-  CaraWifiRemoteStation *station = (CaraWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << size << normally);
+  CaraWifiRemoteStation *station = static_cast<CaraWifiRemoteStation*> (st);
   return normally || station->m_failed >= m_probeThreshold;
 }
 
-bool
-CaraWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/cara-wifi-manager.h ns-3.31/src/wifi/model/cara-wifi-manager.h
--- ns-3.30.1/src/wifi/model/cara-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/cara-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -37,9 +37,9 @@
  * Originally implemented by Federico Maguolo for a very early
  * prototype version of ns-3.
  *
- * This RAA does not support HT, VHT nor HE modes and will error
+ * This RAA does not support HT modes and will error
  * exit if the user tries to configure this RAA with a Wi-Fi MAC
- * that has VhtSupported, HtSupported or HeSupported set.
+ * that supports 802.11n or higher.
  */
 class CaraWifiManager : public WifiRemoteStationManager
 {
@@ -63,20 +63,19 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
   bool DoNeedRts (WifiRemoteStation *station,
-                  Ptr<const Packet> packet, bool normally);
-  bool IsLowLatency (void) const;
+                  uint32_t size, bool normally);
 
-  uint32_t m_timerTimeout; ///< timer threshold
+  uint32_t m_timerTimeout;     ///< timer threshold
   uint32_t m_successThreshold; ///< success threshold
   uint32_t m_failureThreshold; ///< failure threshold
-  uint32_t m_probeThreshold; ///< probe threshold
+  uint32_t m_probeThreshold;   ///< probe threshold
 
   TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/cf-parameter-set.cc ns-3.31/src/wifi/model/cf-parameter-set.cc
--- ns-3.30.1/src/wifi/model/cf-parameter-set.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/cf-parameter-set.cc	2020-06-27 17:38:30.000000000 -0700
@@ -46,7 +46,7 @@
 uint8_t
 CfParameterSet::GetInformationFieldSize () const
 {
-  //we should not be here if pcf is not supported
+  //we should not be here if PCF is not supported
   NS_ASSERT (m_pcfSupported > 0);
   return 6;
 }
@@ -146,14 +146,6 @@
   m_CFPDurRemaining = durRemaining;
 }
 
-/**
- * output operator
- *
- * \param os output stream
- * \param cfParameterSet
- *
- * \return output stream
- */
 std::ostream &
 operator << (std::ostream &os, const CfParameterSet &cfParameterSet)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/cf-parameter-set.h ns-3.31/src/wifi/model/cf-parameter-set.h
--- ns-3.30.1/src/wifi/model/cf-parameter-set.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/cf-parameter-set.h	2020-06-27 17:38:30.000000000 -0700
@@ -35,34 +35,24 @@
 {
 public:
   CfParameterSet ();
-  /**
-   * Set PCF supported function
-   * \param pcfSupported the PCF supported indicator
-   */
-  void SetPcfSupported (uint8_t pcfSupported);
 
-  /**
-   * Element ID function
-   * \returns the wifi information element ID
-   */
+  // Implementations of pure virtual methods of WifiInformationElement
   WifiInformationElementId ElementId () const;
-  /**
-   * Get information field size function
-   * \returns the information field size
-   */
   uint8_t GetInformationFieldSize () const;
-  /**
-   * Serialize information field function
-   * \param start the iterator
-   */
   void SerializeInformationField (Buffer::Iterator start) const;
+  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length);
+  /* This information element is a bit special in that it is only
+     included if the STA is a QoS STA. To support this we
+     override the Serialize and GetSerializedSize methods of
+     WifiInformationElement. */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const;
+  uint16_t GetSerializedSize () const;
+
   /**
-   * Deserialize information field function
-   * \param start the iterator
-   * \param length the length
-   * \returns the size
+   * Set PCF supported function
+   * \param pcfSupported the PCF supported indicator
    */
-  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length);
+  void SetPcfSupported (uint8_t pcfSupported);
 
   /**
    * Return the CFP Count in DTIM frames unit.
@@ -77,72 +67,62 @@
    */
   uint8_t GetCFPPeriod (void) const;
   /**
-   * Return the CFP MaxDuration in microseconds.
+   * Return the maximum CFP duration in microseconds.
    *
-   * \return the CFP MaxDuration in microseconds.
+   * \return the maximum CFP duration in microseconds.
    */
   uint64_t GetCFPMaxDurationUs (void) const;
   /**
-   * Return the CFP DurRemaining in microseconds.
+   * Return the remaining CFP duration in microseconds.
    *
-   * \return the CFP DurRemaining in microseconds
+   * \return the remaining CFP duration in microseconds
    */
   uint64_t GetCFPDurRemainingUs (void) const;
 
   /**
    * Set the CFP Count in DTIM frames unit.
    *
-   * \param cfpcount the CFP Count in DTIM frames unit
+   * \param count the CFP Count in DTIM frames unit
    */
-  void SetCFPCount (uint8_t cfpcount);
+  void SetCFPCount (uint8_t count);
   /**
    * Set the CFP Period in DTIM frames unit.
    *
-   * \param cfpperiod the CFP Period in DTIM frames unit
-   */
-  void SetCFPPeriod (uint8_t cfpperiod);
-  /**
-   * Set the CFP MaxDuration in microseconds.
-   *
-   * \param cfpmaxduration the CFP MaxDuration in microseconds
+   * \param period the CFP Period in DTIM frames unit
    */
-  void SetCFPMaxDurationUs (uint64_t cfpmaxduration);
+  void SetCFPPeriod (uint8_t period);
   /**
-   * Set the CFP MaxDuration in microseconds.
+   * Set the maximum CFP duration in microseconds.
    *
-   * \param cfpdurremaining the CFP DurRemaining in microseconds
+   * \param maxDuration the maximum CFP duration in microseconds
    */
-  void SetCFPDurRemainingUs (uint64_t cfpdurremaining);
-
+  void SetCFPMaxDurationUs (uint64_t maxDuration);
   /**
-   * This information element is a bit special in that it is only
-   * included if the STA is a QoS STA. To support this we
-   * override the Serialize and GetSerializedSize methods of
-   * WifiInformationElement.
-   *
-   * \param start
+   * Set the remaining CFP duration in microseconds.
    *
-   * \return an iterator
+   * \param durRemaining the remaining CFP duration in microseconds
    */
-  Buffer::Iterator Serialize (Buffer::Iterator start) const;
-  /**
-   * Return the serialized size of this EDCA Parameter Set.
-   *
-   * \return the serialized size of this EDCA Parameter Set
-   */
-  uint16_t GetSerializedSize () const;
+  void SetCFPDurRemainingUs (uint64_t durRemaining);
 
 
 private:
   uint8_t m_CFPCount;                 ///< CFP Count
   uint8_t m_CFPPeriod;                ///< CFP Period
-  uint64_t m_CFPMaxDuration;          ///< CFP MaxDuration
-  uint64_t m_CFPDurRemaining;         ///< CFP DurRemaining
+  uint64_t m_CFPMaxDuration;          ///< CFP maximum duration in microseconds
+  uint64_t m_CFPDurRemaining;         ///< CFP remaining duration in microseconds
 
   /// This is used to decide if this element should be added to the frame or not
   uint8_t m_pcfSupported;
 };
 
+/**
+ * output operator
+ *
+ * \param os output stream
+ * \param cfParameterSet the CF Parameter Set
+ *
+ * \return output stream
+ */
 std::ostream &operator << (std::ostream &os, const CfParameterSet &cfParameterSet);
 
 } //namespace ns3
